require 'helper'

class TestProxinacciTest < Test::Unit::TestCase
  def test_start_of_series
    assert_equal(1.closest_fibonacci, 0)
    assert_equal(2.closest_fibonacci, 1)
    assert_equal(5.closest_fibonacci, 3)
    assert_equal(8.closest_fibonacci, 5)
    assert_equal(13.closest_fibonacci, 8)
  end
  
  def test_several_values
    # Produced 10 random numbers in irb and double checked them.
    assert_equal(30.closest_fibonacci, 21)
    assert_equal(304.closest_fibonacci, 233)
    assert_equal(44.closest_fibonacci, 34)
    assert_equal(206.closest_fibonacci, 144)
    assert_equal(436.closest_fibonacci, 377)
    assert_equal(7.closest_fibonacci, 5)
    assert_equal(115.closest_fibonacci, 89)
    assert_equal(232.closest_fibonacci, 144)
    assert_equal(57.closest_fibonacci, 55)
    assert_equal(79.closest_fibonacci, 55)
  end
  
  def test_zero
    0.closest_fibonacci.nil?
  end
  
  def test_negative_value
    -1.closest_fibonacci.nil?
  end
end